/**
 * Component rendering peer: SpWindowPane
 *
 * @author Rakesh 2010-04-21
 * @version $Id: Sync.FileUploadSelector.js 276 2010-01-07 20:20:22Z sptrakesh $
 */
echopoint.consultas.SpWindowPaneSync = Core.extend( Echo.Render.ComponentSync,
{
  $load: function()
  {
    Echo.Render.registerPeer( echopoint.constants.SP_WINDOW_PANE, this );
  },

  maximize: function()
  {
  },

  redraw: function()
  {
  }
} );

echopoint.consultas.DockManager = Core.extend(
{
  $static:
  {
    /** Associative array mapping container ids to arrays of element ids. */
    containerIdToElementIdArrayMap: new Core.Arrays.LargeMap( ),

    add: function( containerId, windowpane )
    {
      var elementIdArray =
          echopoint.consultas.DockManager.containerIdToElementIdArrayMap[containerId];
      if ( !elementIdArray )
      {
        elementIdArray = new Array();
        echopoint.consultas.DockManager.containerIdToElementIdArrayMap[containerId] = elementIdArray;
      }

      for ( var i = 0; i < elementIdArray.length; ++i )
      {
        if ( elementIdArray[i] == windowpane.renderId )
        {
          // Do nothing if re-rendering.
          return;
        }
      }
      elementIdArray[windowpane.renderId] = windowpane;
      echopoint.consultas.DockManager.dock( containerId, windowpane );
    },

    dock: function( containerId, windowpane )
    {
      var elementIdArray = echopoint.consultas.DockManager.containerIdToElementIdArrayMap[containerId];
      if ( !elementIdArray )
      {
        throw new Error( "Invalid container id." );
      }

      var posIndex = elementIdArray.length;
      windowpane.set( "positionX", ( posIndex - 1 ) * 180 );
      windowpane.set( "positionY", windowpane.get( "positionY" ) - 30 );

      return posIndex;
    }
  },

  undock: function( containerId, windowpane )
  {
    var elementIdArray = echopoint.consultas.DockManager.containerIdToElementIdArrayMap[containerId];
    if ( !elementIdArray )
    {
      throw new Error( "DockManager.remove: no data for container with id \"" + containerId + "\"." );
    }

    for ( var i = 0; i < elementIdArray.length; ++i )
    {
      if ( elementIdArray[i] == windowpane.renderId )
      {
        if ( elementIdArray.length == 1 )
        {
          echopoint.consultas.DockManager.containerIdToElementIdArrayMap.remove( containerId );
        }
        else
        {
          if ( i < elementIdArray.length - 1 )
          {
            elementIdArray[i] = elementIdArray[elementIdArray.length - 1];
            var wp = elementIdArray[i];
            wp.set( "positionX", i * 180 );
            wp.set( "positionY", windowpane.get( "positionY" ) - 30 );
            wp.peer.redraw();
          }

          --elementIdArray.length;
        }
        return;
      }
    }
    
    throw new Error( "DockManager.remove: Element with id \"" + windowpane.renderId +
                     "\" does not exist in container with id \"" + containerId + "\"." );
  }
} );
